====== Changelog ======

This page contains a summary of changes between the official [[DokuWiki]] releas
es. Only the biggest changes are listed here. A complete and detailed log of all
 changes is available through the [[https://github.com/dokuwiki/dokuwiki/commits
/master|GitHub Repository Browser]]. (This log on Github is only authoritative f
or major releases. Hotfixes often contain only one or few security fixes.)

Changelogs for releases older than the ones listed here are available at [[Old C
hanges]].

Plugin and template developers should read and subscribe to the [[devel:releases
|detailed change log]].

There is some information regarding the [[install:upgrade|upgrade]]-process.

**Changes marked with :!: need some attention on upgrading!**

===== Release 2025-05-14 "Librarian" =====

  * Refactored Extension Manager now supports dependencies and checks PHP versio
ns. See [[https://www.patreon.com/posts/new-extension-116501986|Patreon Post]]
  * Linkwizard now prefers to create relative links, its JavaScript has been mod
ernized
  * :!: New mechanism to trust proxies. See [[config:trustedproxies|Configuratio
n Setting: trustedproxies]] and [[config:realip|Configuration Setting: realip]]
  * Alternative header for [[devel:authentication#token_auth|Token Authenticatio
n]]
  * More version info in admin screen (for hopefully better bug reports)
  * Various [[devel:remote_api|remote API]] improvements
  * Support for JavaScript nonces provided by environment. See [[issue>3788]]
  * Fixed delete profile form
  * Experimental tree builder support for use by plugin developers. See [[https:
//www.patreon.com/posts/building-trees-125827149|Patreon Post]]
  * Various Bugfixes, language and dependency updates
  * :!: a bunch of methods and classes that had been marked as deprecated in pre
vious versions have been removed. Plugins may need updates.


**Hotfix**

  * 2025-05-14a
    * fix issues related to OS version reading [[issue>4446]] [[issue>4445]]
    * fix issues with locale dependent dates [[issue>4449]]
    * fix issues with styling in Extension Manager
    * no longer complain about missing write permissions for bundled extensions
in Extension Manager
    * adds missing remote API support for Extension Manager
  * 2025-05-14b
    * fix XSS vulnerability in search [[issue>4512]]
===== Release 2024-02-06b “Kaos” =====

  * :!: DokuWiki requires at least PHP 7.4 now
  * Further fixes for warnings in PHP8+
  * Complete Overhaul of the [[devel:Remote API]] and introduction of the [[deve
l:JSONRPC]] transport (see [[https://www.patreon.com/posts/96036243|Patreon Post
]])
  * Introduction of [[devel:Authentication#Token Auth]]
  * Automatic pruning of logs (see [[config:logretain|Configuration Setting: log
retain]])
  * Plugin authors can now set an update message to be shown in extension manage
r
  * Refactored [[syndication|feed generation]]
  * Better baseurl detection when running behind reverse proxy
  * :!: developers now need to install dev dependencies via [[devel:composer]]
  * Automatic loading of [[devel:autoloader#vendor_autoload|vendor/autoload.php]
] for plugins
  * ''SameSite=Lax'' cookie attribute is set by default now (see [[config:samesi
tecookie|Configuration Setting: samesitecookie]])
  * The default [[template:dokuwiki]] template now supports a SVG logo. The logo
 height is now fixed to ''64px'' :!:
  * Lots of [[devel:coding style]] fixes
  * Various bug fixes and smaller tweaks

=== Hotfix ===

  * 2024-02-06a
    * fix problem with parsing uneven table columns [[issue>4186]]
    * fix logo aspect ratio in ''dokuwiki'' template when using PNG logo [[issue
>4187]]
    * re-add missing [[devel:event:feed_data_process|FEED_DATA_PROCESS]] event [
[issue>4191]]
    * fix error handling for plugins with missing info [[issue>4193]]
    * fix doubly declared ''cache'' class error [[issue>4200]]
    * fix content-type header for feeds [[issue>4203]]
    * ignore decryption errors on old cookies [[issue>4198]]
  * 2024-02-06b
    * fix XSS vulnerability in metadata export [[issue>4305]]
===== Release 2023-04-04b “Jack Jackrum” =====

  * A lot of fixes for warnings in PHP8+
    * A new feature flag [[config:hidewarnings]] will suppress the output of war
nings, if PHP is configured to show warnings to the end user
  * The options to embed HTML and PHP have been **completely removed** for secur
ity reasons :!:
    * [[https://forum.dokuwiki.org/d/20628-after-igor-htmlok-and-phpok-will-no-l
onger-be-included-in-the-dokuwiki-core|Forum discussion]]
    * [[plugin:htmlok|Plugin alternative]]
  * Fixes
    * quicksearch with UTF-8 chars
    * basic auth header parsing
    * old revisions for pages with dots
    * feed titles
    * handling of unknown config options
    * relaxed media CSP headers for PDF and SVG handling
    * relaxed browseruid check for better browser compatibility
    * compatibility updates for mail sending
  * Unit Tests use php-dom-wrapper instead of phpquery now :!:
  * Improved error logging
  * Dependency Updates

=== Hotfix ===

  * Hotfix 2023-04-04a
    * fix an XSS security vulnerability in RSS handling [[issue>3967]]
  * Hotfix 2023-04-04b
    * fix XSS vulnerability in metadata export [[issue>4305]]
===== Release 2022-07-31b “Igor” =====

  * Fix various errors in PHP8 support
  * Drop support for PHP versions earlier than 7.2
  * SVG-based smileys replace GIF versions
    * :!: may require template update [[pr>3344]]
    * :!: plugins directly embedding SVG may need CSS adjustments [[issue>3690]]
  * Allow "revert" action for logged in users only
  * Various translation updates
  * Add a class ''.logo'' to the ''h1'' title to let administrators remove the '
'h1'' around the logo [[pr>3408]]
  * Use [[https://github.com/splitbrain/slika | Slika library]] for image resizi
ng and cropping, with:
    * auto rotation based on EXIF tags
    * support for WEBP
  * Refactored logging mechanism [[pr>3230]], [[pr>3203]] and [[.:plugin:logview
er]]
  * Refactored media manager [[pr>3372]] and lazy loading of images
  * Support for SVG images
  * New form events used. :!: Plugins should implement them, because the old for
m events are not triggered anymore
  * Some smaller security fixes
  * :!: On [[farms|farm setups]] a log dir needs to be created manually in anima
ls

=== Hotfix ===

  * Hotfix 2022-07-31a
    * fix an XSS security vulnerability [[issue>3761]]
  * Hotfix 2022-07-31b
    * fix an XSS security vulnerability in RSS handling [[issue>3967]]

===== Release 2020-07-29a “Hogfather” =====

  * Lots of internal refactoring to make the code base more modern and robust. Y
ou can read a bit [[https://www.patreon.com/posts/18685665|more on the backgroun
d here]].
  * Defer the loading of JavaScript to improve initial page loads :!: (Some plug
ins needs to temporary disable the [[config:defer_js]] feature flag)
  * PHP 7.4 compatibility and some preparations for the upcoming PHP8
  * New [[config:trustedproxy]] setting for installations behind a reverse proxy
 :!:
  * New [[plugin:extension#command_line_interface|command line script]] for mana
ging extensions
  * [[syndication#show_new_items_only|RSS Feed]] can now show new items only
  * A whole ton of smaller bug fixes and improvements
  * Lots of translation upgrades

:!: Note: because of various internal changes, not all plugins or templates may
be compatible with this release. It is recommended to check the documentation of
 the plugins you use before upgrading. As always a backup is recommended before
upgrading. :!:

Please also read:

  * [[https://www.patreon.com/posts/38090834|Hogfather Plugin Compatibility]]
  * [[https://forum.dokuwiki.org/d/17863-quick-reminder-what-to-do-when-a-plugin
-doesnt-work-on-hogfather|Quick Reminder: What to do when a plugin doesn't work
on Hogfather]]
  * [[https://www.patreon.com/posts/19048874|DokuWiki Recovery Script]]

And please also ;
  * Search the [[https://forum.dokuwiki.org|Forum]] when you encounter problems,
 chances are high that there are already solutions available
  * If you have no clue where the issue originates, check the [[bugs#server_php_
error_logs|log files of your webserver]].

=== Hotfix ===

  * Hotfix 2020-07-29a
    * fix an XSS security vulnerability [[issue>3761]]

===== Release 2018-04-22c “Greebo” =====

  * This release requires **PHP 5.6** at least! (Red Hat Enterprise Linux does n
ot support beyond PHP 5.5)
  * PHP 7.2 Support and improvements for PHP 7.3 support
  * New form on search page with more search tools :!: Plugins which modified th
at page may need adjustments, e.g. [[plugin:tagging]] Plugin
    * ability to filter and sort results by time! 🎉
  * Sending now a ''manifest.json'' to let the user add DokuWiki to the homescre
en
  * Re-factored section edit. :!: Plugins which insert own [[devel:section_edito
r|section edit buttons]] need adjustments, e.g. [[plugin:wrap]] Plugin
  * updated LESS compiler :!: [[devel:templates|Template]] authors may experienc
e some incompatibilities
  * new Action Dispatcher :!: Plugin authors handling [[devel:event:ACTION_ACT_P
REPROCESS]] may encounter slight differences
  * new [[https://www.patreon.com/posts/command-line-15335339|Command Line Plugi
ns]]
  * new [[https://www.patreon.com/posts/menus-14160215|Menu system]] :!: templat
e authors may want to integrate them (see [[devel:menus|Menu]])
  * improved features in bin/wantedpage.php CLI
  * better cursor handling when inserting multiple images from media popup
  * [[syntax_highlighting|additional options]] for GeShi syntax highlighting

=== Hotfix ===

  * Hotfix 2018-04-22a
    * fix missing "you are here" [[issue>2329]]
    * readd missing password reset interface [[issue>2349]]
    * fix page unlocking when canceling edits [[issue>2350]]
    * better support for creating pages from search [[issue>2355]]
    * problems with installing plugin zips on some systems [[issue>2361]]
    * fixed draft recovering
  * Hotfix 2018-04-22b
    * fix PHP 7.3 compatibility [[issue>2622]]
    * fix ACL check [[PR>2609]]
  * Hotfix 2018-04-22c
    * fix an XSS Vulnerability [[issue>3044]]

===== Release 2017-02-19g “Frusterick Manners” =====

  * new Admin screen with plugins being able to add their own icons :!: 3rd part
y templates need adjustments
  * jQuery 3 (IE Support for versions <9 dropped)
  * :!: some plugins may need an update.
    * [[plugin:Gallery]]: Make sure to update the gallery plugin before you upgr
ade DokuWiki. Versions before 2016-12-22 render all pages in Frusterick Manners
virtually unusable. This includes the login and the admin forms. (Rescue manoeuv
re if you happened to fall into the trap: Use regular file tools to move the fol
der '$DOKUWIKIROOT/lib/plugins/gallery' out of the way.)
    * [[plugin:ODT]]: Versions before 2016-09-10 do not supply the file 'inc/Zip
Lib.class.php' which is required in Frusterick Manners.
  * better cache management and CDN support for jQuery
  * PHP 7.1 support and PHP 7.0 bugfixes
  * improvements to the internal Form mechanism
  * File usage list in media manager
  * Various improvements, language updates and bug fixes
  * :!: XMLRPC is only available for PHP 5.4 and higher due to [[issue>1947|usag
e of certain PHP syntax]]

=== Hotfix ===

  * Hotfix 2017-02-19a: fixes installation issue [[issue>1852]] and media overwr
ite issue [[issue>1853]].
  * Hotfix 2017-02-19b: fixes security token [[issue>1883]] and media manager ov
erwrite issue [[issue>1864]].
  * Hotfix 2017-02-19c: fixes reflected XSS issue [[issue>2061]]
  * Hotfix 2017-02-19d: fixes sanitation of $language [[issue>2080]]; fixes RSS
syntax XSS [[issue>2081]]
  * Hotfix 2017-02-19e: fixes rendering null $language going to GeSHi [[issue>20
88]]
  * Hotfix 2017-02-19f: fixes PHP 7.3 compatibility [[issue>2622]] and ACL check
 [[PR>2609]]
  * Hotfix 2017-02-19g: fixes an XSS Vulnerability [[issue>3044]]

===== Release 2016-06-26e “Elenor of Tsort” =====

  * New [[plugin:authPDO]] plugin; [[plugin:authmysql]] and [[plugin:authpgsql]]
 are deprecated :!:
  * :!: Access check is performed before pages are shown in sidebars of recent t
emplates. (e.g. dokuwiki, starter, writr)
  * PHP 7 compatibility fixes
  * Internet Explorers 8 (and older) are no longer supported, workarounds have b
een removed
  * Improvements to the new [[devel:form]] class, [[devel:autoloader|auto loadin
g]] of plugin classes and other improvements for plugin developers
  * Show size changes in recent changes
  * Better RTL (Arabic, Hebrew) support in Mediamanager
  * Support for PHP's builtin web server
  * Various improvements, language updates and bug fixes
  * Old authentication configurations are not loaded anymore. Requires for some
a manual update of configuration settings. (You need to change e.g. ''$conf['aut
h']['ldap']'' -> ''$conf['plugin']['authldap']'' and ''$conf['authtype'] = 'ldap
''' -> ''$conf['authtype'] = 'authldap'''.) [[issue>1535]]

=== Hotfix ===

  * Hotfix 2016-06-26a: fixes [[issue>1616]] issue with authad.
  * Hotfix 2016-06-26b: fixes security issue [[issue>1883]], and adjusts session
 ID check to specification.
  * Hotfix 2016-06-26c: fixes reflected XSS issue [[issue>2061]]
  * Hotfix 2016-06-26d: What changed???
  * Hotfix 2016-06-26e: fix rendering null $language going to GeSHi [[issue>2088
]]

===== Release 2015-08-10a “Detritus” =====

  * This release now requires PHP 5.3.3 at least
  * New [[plugin:styling|Style Manager]] to adjust template variables like color
s
  * Experimental new Form class usable for plugin developers
  * Use [[https://getcomposer.org/|Composer]] to add third party libraries
  * Various deprecated code has been removed
  * The [[plugin:extension|Extension Manager]] can now remove old files when upd
ating extensions
  * Allow [[issue>1158|unsetting default]] acronyms, schemes, entities, etc. in
local config
  * PHP 7 compatibility fixes
  * Page titles now reflect the current action better
  * Add [[devel:event:plugin_popularity_data_setup|event to let plugin authors s
end their own popularity data]]
  * Changed all submit buttons from ''input'' to ''button'' to improve their sty
lability. :!:
  * Various improvements and bug fixes

=== Hotfix ===

  * Hotfix 2015-08-10a: fix for issue [[issue>1296]] with Extension Manager whic
h prevented installing tarballs and issue [[issue>1302]] which prevented links t
o Windows Shares to work



Previous releases are on **[[Old Changes]].**
